#!/usr/bin/perl
# -*- mode: perl -*-

use strict;
use Time::Local;

my $year = 2007;
my $mon	 = 8;
my $mday = 8;

my $time = timelocal(0, 0, 0, $mday, $mon-1, $year);

# ΐubN
my $major_blocks = ['A'..'H'];
my $minor_blocks = [];

# ubN4푊
my $block_steps = 4;

# ΐҐ (ȗ2Ƃ݂Ȃ)
my $versus = [3, 3, 2];

# ̎ (ȗ1Ƃ݂Ȃ)
my $games  = [3, 2, 2];

# Jn
my $start = '11';

# x݂鎎
my $yasumi = {
	'C1-1' => [5, '12'],
	'E1-1' => [1, '13'],
	'G1-1' => [1, '14'],
	'A2-1' => [1, '2O'],
	'E2-1' => [1, '2㔼'],
	'A3-1' => [2, '3'],
	'A4-1' => [2, '4'],
	'Z1-1' => [2],
};

my $match_hash = {};

my($major_block, $minor_block, $minor, $step, $block, $match, $entry, $entry_max);

foreach $major_block (@$major_blocks) {
	$block = sprintf("%s%d-1", $major_block, $block_steps);
	$match_hash->{$block} = {};
}

my $minor_max = 1;
my $entry = 2;
for ($step = $block_steps; $step > 0; $step--) {
	$entry = $versus->[$step-1];
	$entry = 2	unless $entry;

	foreach $major_block (@$major_blocks) {
		$minor = 1;
		$minor_blocks->[$step] = $minor_max;
		for ($minor_block = 1; $minor_block <= $minor_max; $minor_block++) {
			$block = sprintf("%s%d-%d", $major_block, $step, $minor_block);
			$match = $match_hash->{$block};
			$match->{block} = $block;
			$match->{prev}	= [];

			foreach (1..$entry) {
				$block = sprintf("%s%d-%d", $major_block, $step-1, $minor);
				$match_hash->{$block} = {};
				push(@{$match->{prev}}, $match_hash->{$block});
				$minor++;
			}
		}
	}
	$minor_max *= $entry;
}
$minor_blocks->[0] = $minor_max;

printf("##  [[ { ]]\n# %s\n", $start);
foreach $step (1..$block_steps) {
	my $match_array = [];
	my $game_count  = $games->[$step-1];
	$game_count = 1  unless $game_count;
	foreach $major_block (@$major_blocks) {
		foreach $minor (1..$minor_blocks->[$step]) {
			$block = sprintf("%s%d-%d", $major_block, $step, $minor);
			$match = $match_hash->{$block};
			push(@$match_array, $match)  if $match;
		}
	}
	&schedule($match_hash, $match_array, $step, $game_count, $minor_blocks->[$step] / $game_count, \$time);
}

if ($yasumi->{'Z1-1'}) {
	my $array = $yasumi->{'Z1-1'};
	my($sec, $min, $hour, $mday, $mon, $year, $wday) = localtime($time);
	my $date = sprintf('%d/%d', $mon+1, $mday);
	my $days  = 1;
	$days = $array->[0]  if $array->[0];
	if ($days > 1) {
		$time += (60 * 60 * 24 * ($days-1));
		($sec, $min, $hour, $mday, $mon, $year, $wday) = localtime($time);
		printf("# x %s-%s\n", $date, sprintf('%d/%d', $mon+1, $mday));
	} else {
		printf("# x %s\n", $date);
	}
	$time += (60 * 60 * 24);
	my($sec, $min, $hour, $mday, $mon, $year, $wday) = localtime($time);
	$date = sprintf('%d/%d', $mon+1, $mday);
}
printf("##  [[ g[ig ]]\n");


sub schedule {
	my $match_hash  = shift;
	my $match_array = shift;
	my $step  = shift;
	my $count = shift;	# 1̎
	my $inc   = shift;	#
	my $time  = shift;	# JÓ
	my $entry;

	my($match, $i);
	my @index;
	for ($i = 0; $i < $count * 8; $i++) {
		$index[$i] = $i * $inc;
	}

  DATE:
	while (1) {
		my($sec, $min, $hour, $mday, $mon, $year, $wday) = localtime($$time);
		my $date = sprintf('%d/%d', $mon+1, $mday);
		for ($i = 0; $i < $count; $i++) {
			$match = $match_array->[$index[$i]];
		  EXIST:
			while (1) {
				return  unless ($match && $match->{block});
				return  unless $match->{block} =~ /^[A-Z]$step/;
				last EXIST  unless $match->{date};
				$index[$i] += $inc;
				$match = $match_array->[$index[$i]];
			}
			if ($yasumi->{$match->{block}}) {
				my $array = $yasumi->{$match->{block}};
				my $days  = 1;
				$days = $array->[0]  if $array->[0];
				if ($days > 1) {
					$$time += (60 * 60 * 24 * ($days-1));
					($sec, $min, $hour, $mday, $mon, $year, $wday) = localtime($$time);
					printf("# x %s-%s\n", $date, sprintf('%d/%d', $mon+1, $mday));
				} else {
					printf("# x %s\n", $date);
				}
				$$time += (60 * 60 * 24);
				($sec, $min, $hour, $mday, $mon, $year, $wday) = localtime($$time);
				$date = sprintf('%d/%d', $mon+1, $mday);
				printf("##  %s\n", $array->[1])  if $array->[1];
			}
			$match->{date} = $date;
			if ($match->{block} =~ /([A-Z])1\-(\d+)/) {
				my $alias = sprintf("%s%02d", $1, $2);
				print $match->{block}, '<>', $match->{date}, "<><><>$alias<>";
			} else {
				print $match->{block}, '<>', $match->{date}, "<><><><>";
			}
			my $first = 1;
			foreach my $prev (@{$match->{prev}}) {
				if ($prev->{block}) {
					if ($first) {
						$first = 0;
					} else {
						print ","  ;
					}
					print $prev->{block};
				}
			}
			print "\n";

			$index[$i] ++;
		}
		$$time += (60 * 60 * 24);
	}
}


# Local Variables:
# tab-width:4
# End:
